package finance.chai.chai_webview_plugin;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

public class WebviewBuildParams implements Serializable {
    public boolean hidden;
    public String url;
    public String userAgent;
    public boolean withJavascript;
    public boolean clearCache;
    public boolean clearCookies;
    public boolean withZoom;
    public boolean withLocalStorage;
    public boolean supportMultipleWindows;
    public boolean appCacheEnabled;
    public Map<String, String> headers;
    public boolean scrollBar;
    public boolean allowFileURLs;
    public boolean useWideViewPort;
    public String invalidUrlRegex;
    public boolean geolocationEnabled;
    public Map<String, String> authCookies;


    public static WebviewBuildParams newIsntance(MethodCall call) {
        WebviewBuildParams params = new WebviewBuildParams();
        boolean hidden = call.argument("hidden");
        String url = call.argument("url");
        String userAgent = call.argument("userAgent");
        boolean withJavascript = call.argument("withJavascript");
        boolean clearCache = call.argument("clearCache");
        boolean clearCookies = call.argument("clearCookies");
        boolean withZoom = call.argument("withZoom");
        boolean withLocalStorage = call.argument("withLocalStorage");
        boolean supportMultipleWindows = call.argument("supportMultipleWindows");
        boolean appCacheEnabled = call.argument("appCacheEnabled");
        Map<String, String> headers = call.argument("headers");
        boolean scrollBar = call.argument("scrollBar");
        boolean allowFileURLs = call.argument("allowFileURLs");
        boolean useWideViewPort = call.argument("useWideViewPort");
        String invalidUrlRegex = call.argument("invalidUrlRegex");
        boolean geolocationEnabled = call.argument("geolocationEnabled");
        HashMap authCookies = call.argument("authCookies");
        params.hidden = hidden;
        params.url = url;
        params.userAgent = userAgent;
        params.withJavascript = withJavascript;
        params.clearCache = clearCache;
        params.clearCookies = clearCookies;
        params.withZoom = withZoom;
        params.withLocalStorage = withLocalStorage;
        params.supportMultipleWindows = supportMultipleWindows;
        params.appCacheEnabled = appCacheEnabled;
        params.headers = headers;
        params.scrollBar = scrollBar;
        params.allowFileURLs = allowFileURLs;
        params.useWideViewPort = useWideViewPort;
        params.invalidUrlRegex = invalidUrlRegex;
        params.geolocationEnabled = geolocationEnabled;
        params.authCookies = authCookies;
        return params;
    }

    public static WebviewBuildParams newInstance(Map<String, Object> params) {
        WebviewBuildParams buildParams = new WebviewBuildParams();
        boolean hidden = false;
        try {
            hidden = (boolean) params.get("hidden");
        } catch (Exception e) {
            //ignore
        }
        String url = null;
        try {
            url = (String) params.get("url");
        } catch (Exception e) {
            //ignore
        }
        String userAgent = null;
        try {
            userAgent = (String) params.get("userAgent");
        } catch (Exception e) {
            //ignore
        }
        boolean withJavascript = false;
        try {
            withJavascript = (boolean) params.get("withJavascript");
        } catch (Exception e) {
            //ignore
        }
        boolean clearCache = false;
        try {
            clearCache = (boolean) params.get("clearCache");
        } catch (Exception e) {
            //ignore
        }
        boolean clearCookies = false;
        try {
            clearCookies = (boolean) params.get("clearCookies");
        } catch (Exception e) {
            //ignore
        }
        boolean withZoom = false;
        try {
            withZoom = (boolean) params.get("withZoom");
        } catch (Exception e) {
            //ignore
        }
        boolean withLocalStorage = false;
        try {
            withLocalStorage = (boolean) params.get("withLocalStorage");
        } catch (Exception e) {
            //ignore
        }
        boolean supportMultipleWindows = false;
        try {
            supportMultipleWindows = (boolean) params.get("supportMultipleWindows");
        } catch (Exception e) {
            //ignore
        }
        boolean appCacheEnabled = false;
        try {
            appCacheEnabled = (boolean) params.get("appCacheEnabled");
        } catch (Exception e) {
            //ignore
        }
        Map<String, String> headers = null;
        try {
            headers = (Map<String, String>) params.get("headers");
        } catch (Exception e) {
            //ignore
        }
        boolean scrollBar = false;
        try {
            scrollBar = (boolean) params.get("scrollBar");
        } catch (Exception e) {
            //ignore
        }
        boolean allowFileURLs = false;
        try {
            allowFileURLs = (boolean) params.get("allowFileURLs");
        } catch (Exception e) {
            //ignore
        }
        boolean useWideViewPort = false;
        try {
            useWideViewPort = (boolean) params.get("useWideViewPort");
        } catch (Exception e) {
            //ignore
        }
        String invalidUrlRegex = null;
        try {
            invalidUrlRegex = (String) params.get("invalidUrlRegex");
        } catch (Exception e) {
            //ignore
        }
        boolean geolocationEnabled = false;
        try {
            geolocationEnabled = (boolean) params.get("geolocationEnabled");
        } catch (Exception e) {
            //ignore
        }
        Map authCookies = null;
        try {
            authCookies = (Map) params.get("authCookies");
        } catch (Exception e) {
            //ignore
        }
        buildParams.hidden = hidden;
        buildParams.url = url;
        buildParams.userAgent = userAgent;
        buildParams.withJavascript = withJavascript;
        buildParams.clearCache = clearCache;
        buildParams.clearCookies = clearCookies;
        buildParams.withZoom = withZoom;
        buildParams.withLocalStorage = withLocalStorage;
        buildParams.supportMultipleWindows = supportMultipleWindows;
        buildParams.appCacheEnabled = appCacheEnabled;
        buildParams.headers = headers;
        buildParams.scrollBar = scrollBar;
        buildParams.allowFileURLs = allowFileURLs;
        buildParams.useWideViewPort = useWideViewPort;
        buildParams.invalidUrlRegex = invalidUrlRegex;
        buildParams.geolocationEnabled = geolocationEnabled;
        buildParams.authCookies = authCookies;
        return buildParams;
    }
}
