#import "ChaiWebviewPlugin.h"
#import "ChaiWebPlatformView.h"


@interface ChaiWebviewPlugin() {
  NSObject<FlutterBinaryMessenger> *messenger;
}
@end

@implementation ChaiWebviewPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  UIViewController *viewController = [UIApplication sharedApplication].delegate.window.rootViewController;
  ChaiWebviewPlugin* instance = [[ChaiWebviewPlugin alloc] initWithViewController:viewController binaryMessenger:registrar.messenger];
  [registrar registerViewFactory:instance withId:@"chai_webview"];
}

- (id)initWithViewController:(UIViewController *)viewController
             binaryMessenger: (NSObject<FlutterBinaryMessenger>*)_messenger {
  self = [super init];
  if (self) {
    self.viewController = viewController;
    messenger = _messenger;
  }
  return self;
}

- (NSObject<FlutterMessageCodec> *)createArgsCodec {
  return [FlutterStandardMessageCodec sharedInstance];
}

- (nonnull NSObject<FlutterPlatformView> *)createWithFrame:(CGRect)frame
                                            viewIdentifier:(int64_t)viewId
                                                 arguments:(id _Nullable)args {
  return [[ChaiWebPlatformView alloc] initWithArgs:args
                                    viewIdentifier:viewId
                                   binaryMessenger:messenger
                                             frame:frame
                                    viewController:self.viewController];
}

@end
